// -*- c++ -*-
/*
  Copyright 2003 John Knottenbelt
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#if !defined __LINEINPUTBUFFER_H
#define __LINEINPUTBUFFER_H

#include "select.h"
#include <string>

/** This class is not implemented or used. The intention was that
    it would be used to read lines, however, this functionality
    was added in slightly less efficient form to CircularBuffer */

class LineInputBuffer : public Selectable {
public:
  LineInputBuffer(InputBuffer *buffer);

  void addSelectFDs(Select &) const;
  bool isReady(const Select &) const;
  bool process();

  bool getLine(std::string &line);
private:
  std::string line;
  InputBuffer *inner;
};

#endif // __LINEINPUTBUFFER_H
