// -*- c++ -*-
/*
  Copyright 2003 John Knottenbelt
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#if !defined __UNIXCLIENTSOCKET_H
#define __UNIXCLIENTSOCKET_H

#include "select.h"
#include <string>

class InputBuffer;
class OutputBuffer;

class UnixClientSocket : public Selectable {
public:
  UnixClientSocket(const std::string &path);
  virtual ~UnixClientSocket();
  
  bool connect(const std::string &path);
  void setBlocking(bool mode);
  bool isBlocking() const;
  operator bool() const;

  bool write(const std::string &data);
  int read(char *data, int size);
  bool readLine(std::string &line);

  virtual void addSelectFDs(Select &) const;
  virtual bool isReady(const Select &) const;
  bool processReady(const Select &);

  bool writeCredentials();

private:
  bool getMoreData();

  int fd;
  bool blocking;
  bool overflowed;
  InputBuffer *input;
  OutputBuffer *output;
};

#endif // __UNIXCLIENTSOCKET_H
